// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.34.2
// 	protoc        v3.21.12
// source: yandex/cloud/iam/v1/refresh_token.proto

package iam

import (
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	timestamppb "google.golang.org/protobuf/types/known/timestamppb"
	reflect "reflect"
	sync "sync"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

// Protection level of the refresh token.
type RefreshToken_ProtectionLevel int32

const (
	RefreshToken_PROTECTION_LEVEL_UNSPECIFIED RefreshToken_ProtectionLevel = 0
	// Refresh token without DPOP
	RefreshToken_NO_PROTECTION RefreshToken_ProtectionLevel = 1
	// Refresh token with dpop. The dpop key is not a YubiKey PIV key with required pin/touch policy and attestation.
	RefreshToken_INSECURE_KEY_DPOP RefreshToken_ProtectionLevel = 2
	// Refresh token with dpop. The dpop key is a YubiKey PIV key with required pin/touch policy and attestation.
	RefreshToken_SECURE_KEY_DPOP RefreshToken_ProtectionLevel = 3
)

// Enum value maps for RefreshToken_ProtectionLevel.
var (
	RefreshToken_ProtectionLevel_name = map[int32]string{
		0: "PROTECTION_LEVEL_UNSPECIFIED",
		1: "NO_PROTECTION",
		2: "INSECURE_KEY_DPOP",
		3: "SECURE_KEY_DPOP",
	}
	RefreshToken_ProtectionLevel_value = map[string]int32{
		"PROTECTION_LEVEL_UNSPECIFIED": 0,
		"NO_PROTECTION":                1,
		"INSECURE_KEY_DPOP":            2,
		"SECURE_KEY_DPOP":              3,
	}
)

func (x RefreshToken_ProtectionLevel) Enum() *RefreshToken_ProtectionLevel {
	p := new(RefreshToken_ProtectionLevel)
	*p = x
	return p
}

func (x RefreshToken_ProtectionLevel) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (RefreshToken_ProtectionLevel) Descriptor() protoreflect.EnumDescriptor {
	return file_yandex_cloud_iam_v1_refresh_token_proto_enumTypes[0].Descriptor()
}

func (RefreshToken_ProtectionLevel) Type() protoreflect.EnumType {
	return &file_yandex_cloud_iam_v1_refresh_token_proto_enumTypes[0]
}

func (x RefreshToken_ProtectionLevel) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use RefreshToken_ProtectionLevel.Descriptor instead.
func (RefreshToken_ProtectionLevel) EnumDescriptor() ([]byte, []int) {
	return file_yandex_cloud_iam_v1_refresh_token_proto_rawDescGZIP(), []int{0, 0}
}

type RefreshToken struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// Refresh Token id.
	Id string `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	// Information about the app for which the Refresh Token was issued.
	ClientInstanceInfo string `protobuf:"bytes,2,opt,name=client_instance_info,json=clientInstanceInfo,proto3" json:"client_instance_info,omitempty"`
	// The OAuth client identifier for which the Refresh Token was issued.
	ClientId string `protobuf:"bytes,3,opt,name=client_id,json=clientId,proto3" json:"client_id,omitempty"`
	// The subject identifier for whom the Refresh Token was issued.
	SubjectId string `protobuf:"bytes,4,opt,name=subject_id,json=subjectId,proto3" json:"subject_id,omitempty"`
	// Refresh token creation time.
	CreatedAt *timestamppb.Timestamp `protobuf:"bytes,5,opt,name=created_at,json=createdAt,proto3" json:"created_at,omitempty"`
	// Refresh token expiration time.
	ExpiresAt *timestamppb.Timestamp `protobuf:"bytes,6,opt,name=expires_at,json=expiresAt,proto3" json:"expires_at,omitempty"`
	// Timestamp for the last authentication using this Refresh Token.
	LastUsedAt *timestamppb.Timestamp `protobuf:"bytes,7,opt,name=last_used_at,json=lastUsedAt,proto3" json:"last_used_at,omitempty"`
	// Protection level of the refresh token.
	//
	// It shows whether DPOP was used to protect the Refresh Token and and the level of security of the storage used for the DPOP key.
	ProtectionLevel RefreshToken_ProtectionLevel `protobuf:"varint,8,opt,name=protection_level,json=protectionLevel,proto3,enum=yandex.cloud.iam.v1.RefreshToken_ProtectionLevel" json:"protection_level,omitempty"`
}

func (x *RefreshToken) Reset() {
	*x = RefreshToken{}
	if protoimpl.UnsafeEnabled {
		mi := &file_yandex_cloud_iam_v1_refresh_token_proto_msgTypes[0]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *RefreshToken) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*RefreshToken) ProtoMessage() {}

func (x *RefreshToken) ProtoReflect() protoreflect.Message {
	mi := &file_yandex_cloud_iam_v1_refresh_token_proto_msgTypes[0]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use RefreshToken.ProtoReflect.Descriptor instead.
func (*RefreshToken) Descriptor() ([]byte, []int) {
	return file_yandex_cloud_iam_v1_refresh_token_proto_rawDescGZIP(), []int{0}
}

func (x *RefreshToken) GetId() string {
	if x != nil {
		return x.Id
	}
	return ""
}

func (x *RefreshToken) GetClientInstanceInfo() string {
	if x != nil {
		return x.ClientInstanceInfo
	}
	return ""
}

func (x *RefreshToken) GetClientId() string {
	if x != nil {
		return x.ClientId
	}
	return ""
}

func (x *RefreshToken) GetSubjectId() string {
	if x != nil {
		return x.SubjectId
	}
	return ""
}

func (x *RefreshToken) GetCreatedAt() *timestamppb.Timestamp {
	if x != nil {
		return x.CreatedAt
	}
	return nil
}

func (x *RefreshToken) GetExpiresAt() *timestamppb.Timestamp {
	if x != nil {
		return x.ExpiresAt
	}
	return nil
}

func (x *RefreshToken) GetLastUsedAt() *timestamppb.Timestamp {
	if x != nil {
		return x.LastUsedAt
	}
	return nil
}

func (x *RefreshToken) GetProtectionLevel() RefreshToken_ProtectionLevel {
	if x != nil {
		return x.ProtectionLevel
	}
	return RefreshToken_PROTECTION_LEVEL_UNSPECIFIED
}

var File_yandex_cloud_iam_v1_refresh_token_proto protoreflect.FileDescriptor

var file_yandex_cloud_iam_v1_refresh_token_proto_rawDesc = []byte{
	0x0a, 0x27, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2f, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2f, 0x69,
	0x61, 0x6d, 0x2f, 0x76, 0x31, 0x2f, 0x72, 0x65, 0x66, 0x72, 0x65, 0x73, 0x68, 0x5f, 0x74, 0x6f,
	0x6b, 0x65, 0x6e, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x12, 0x13, 0x79, 0x61, 0x6e, 0x64, 0x65,
	0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x69, 0x61, 0x6d, 0x2e, 0x76, 0x31, 0x1a, 0x1f,
	0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2f,
	0x74, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x22,
	0x92, 0x04, 0x0a, 0x0c, 0x52, 0x65, 0x66, 0x72, 0x65, 0x73, 0x68, 0x54, 0x6f, 0x6b, 0x65, 0x6e,
	0x12, 0x0e, 0x0a, 0x02, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x02, 0x69, 0x64,
	0x12, 0x30, 0x0a, 0x14, 0x63, 0x6c, 0x69, 0x65, 0x6e, 0x74, 0x5f, 0x69, 0x6e, 0x73, 0x74, 0x61,
	0x6e, 0x63, 0x65, 0x5f, 0x69, 0x6e, 0x66, 0x6f, 0x18, 0x02, 0x20, 0x01, 0x28, 0x09, 0x52, 0x12,
	0x63, 0x6c, 0x69, 0x65, 0x6e, 0x74, 0x49, 0x6e, 0x73, 0x74, 0x61, 0x6e, 0x63, 0x65, 0x49, 0x6e,
	0x66, 0x6f, 0x12, 0x1b, 0x0a, 0x09, 0x63, 0x6c, 0x69, 0x65, 0x6e, 0x74, 0x5f, 0x69, 0x64, 0x18,
	0x03, 0x20, 0x01, 0x28, 0x09, 0x52, 0x08, 0x63, 0x6c, 0x69, 0x65, 0x6e, 0x74, 0x49, 0x64, 0x12,
	0x1d, 0x0a, 0x0a, 0x73, 0x75, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x5f, 0x69, 0x64, 0x18, 0x04, 0x20,
	0x01, 0x28, 0x09, 0x52, 0x09, 0x73, 0x75, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x49, 0x64, 0x12, 0x39,
	0x0a, 0x0a, 0x63, 0x72, 0x65, 0x61, 0x74, 0x65, 0x64, 0x5f, 0x61, 0x74, 0x18, 0x05, 0x20, 0x01,
	0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74,
	0x6f, 0x62, 0x75, 0x66, 0x2e, 0x54, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x52, 0x09,
	0x63, 0x72, 0x65, 0x61, 0x74, 0x65, 0x64, 0x41, 0x74, 0x12, 0x39, 0x0a, 0x0a, 0x65, 0x78, 0x70,
	0x69, 0x72, 0x65, 0x73, 0x5f, 0x61, 0x74, 0x18, 0x06, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e,
	0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e,
	0x54, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x52, 0x09, 0x65, 0x78, 0x70, 0x69, 0x72,
	0x65, 0x73, 0x41, 0x74, 0x12, 0x3c, 0x0a, 0x0c, 0x6c, 0x61, 0x73, 0x74, 0x5f, 0x75, 0x73, 0x65,
	0x64, 0x5f, 0x61, 0x74, 0x18, 0x07, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67, 0x6f, 0x6f,
	0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x54, 0x69, 0x6d,
	0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x52, 0x0a, 0x6c, 0x61, 0x73, 0x74, 0x55, 0x73, 0x65, 0x64,
	0x41, 0x74, 0x12, 0x5c, 0x0a, 0x10, 0x70, 0x72, 0x6f, 0x74, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e,
	0x5f, 0x6c, 0x65, 0x76, 0x65, 0x6c, 0x18, 0x08, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x31, 0x2e, 0x79,
	0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x69, 0x61, 0x6d, 0x2e,
	0x76, 0x31, 0x2e, 0x52, 0x65, 0x66, 0x72, 0x65, 0x73, 0x68, 0x54, 0x6f, 0x6b, 0x65, 0x6e, 0x2e,
	0x50, 0x72, 0x6f, 0x74, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x4c, 0x65, 0x76, 0x65, 0x6c, 0x52,
	0x0f, 0x70, 0x72, 0x6f, 0x74, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x4c, 0x65, 0x76, 0x65, 0x6c,
	0x22, 0x72, 0x0a, 0x0f, 0x50, 0x72, 0x6f, 0x74, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x4c, 0x65,
	0x76, 0x65, 0x6c, 0x12, 0x20, 0x0a, 0x1c, 0x50, 0x52, 0x4f, 0x54, 0x45, 0x43, 0x54, 0x49, 0x4f,
	0x4e, 0x5f, 0x4c, 0x45, 0x56, 0x45, 0x4c, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46,
	0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x11, 0x0a, 0x0d, 0x4e, 0x4f, 0x5f, 0x50, 0x52, 0x4f, 0x54,
	0x45, 0x43, 0x54, 0x49, 0x4f, 0x4e, 0x10, 0x01, 0x12, 0x15, 0x0a, 0x11, 0x49, 0x4e, 0x53, 0x45,
	0x43, 0x55, 0x52, 0x45, 0x5f, 0x4b, 0x45, 0x59, 0x5f, 0x44, 0x50, 0x4f, 0x50, 0x10, 0x02, 0x12,
	0x13, 0x0a, 0x0f, 0x53, 0x45, 0x43, 0x55, 0x52, 0x45, 0x5f, 0x4b, 0x45, 0x59, 0x5f, 0x44, 0x50,
	0x4f, 0x50, 0x10, 0x03, 0x42, 0x56, 0x0a, 0x17, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2e, 0x63,
	0x6c, 0x6f, 0x75, 0x64, 0x2e, 0x61, 0x70, 0x69, 0x2e, 0x69, 0x61, 0x6d, 0x2e, 0x76, 0x31, 0x5a,
	0x3b, 0x67, 0x69, 0x74, 0x68, 0x75, 0x62, 0x2e, 0x63, 0x6f, 0x6d, 0x2f, 0x79, 0x61, 0x6e, 0x64,
	0x65, 0x78, 0x2d, 0x63, 0x6c, 0x6f, 0x75, 0x64, 0x2f, 0x67, 0x6f, 0x2d, 0x67, 0x65, 0x6e, 0x70,
	0x72, 0x6f, 0x74, 0x6f, 0x2f, 0x79, 0x61, 0x6e, 0x64, 0x65, 0x78, 0x2f, 0x63, 0x6c, 0x6f, 0x75,
	0x64, 0x2f, 0x69, 0x61, 0x6d, 0x2f, 0x76, 0x31, 0x3b, 0x69, 0x61, 0x6d, 0x62, 0x06, 0x70, 0x72,
	0x6f, 0x74, 0x6f, 0x33,
}

var (
	file_yandex_cloud_iam_v1_refresh_token_proto_rawDescOnce sync.Once
	file_yandex_cloud_iam_v1_refresh_token_proto_rawDescData = file_yandex_cloud_iam_v1_refresh_token_proto_rawDesc
)

func file_yandex_cloud_iam_v1_refresh_token_proto_rawDescGZIP() []byte {
	file_yandex_cloud_iam_v1_refresh_token_proto_rawDescOnce.Do(func() {
		file_yandex_cloud_iam_v1_refresh_token_proto_rawDescData = protoimpl.X.CompressGZIP(file_yandex_cloud_iam_v1_refresh_token_proto_rawDescData)
	})
	return file_yandex_cloud_iam_v1_refresh_token_proto_rawDescData
}

var file_yandex_cloud_iam_v1_refresh_token_proto_enumTypes = make([]protoimpl.EnumInfo, 1)
var file_yandex_cloud_iam_v1_refresh_token_proto_msgTypes = make([]protoimpl.MessageInfo, 1)
var file_yandex_cloud_iam_v1_refresh_token_proto_goTypes = []any{
	(RefreshToken_ProtectionLevel)(0), // 0: yandex.cloud.iam.v1.RefreshToken.ProtectionLevel
	(*RefreshToken)(nil),              // 1: yandex.cloud.iam.v1.RefreshToken
	(*timestamppb.Timestamp)(nil),     // 2: google.protobuf.Timestamp
}
var file_yandex_cloud_iam_v1_refresh_token_proto_depIdxs = []int32{
	2, // 0: yandex.cloud.iam.v1.RefreshToken.created_at:type_name -> google.protobuf.Timestamp
	2, // 1: yandex.cloud.iam.v1.RefreshToken.expires_at:type_name -> google.protobuf.Timestamp
	2, // 2: yandex.cloud.iam.v1.RefreshToken.last_used_at:type_name -> google.protobuf.Timestamp
	0, // 3: yandex.cloud.iam.v1.RefreshToken.protection_level:type_name -> yandex.cloud.iam.v1.RefreshToken.ProtectionLevel
	4, // [4:4] is the sub-list for method output_type
	4, // [4:4] is the sub-list for method input_type
	4, // [4:4] is the sub-list for extension type_name
	4, // [4:4] is the sub-list for extension extendee
	0, // [0:4] is the sub-list for field type_name
}

func init() { file_yandex_cloud_iam_v1_refresh_token_proto_init() }
func file_yandex_cloud_iam_v1_refresh_token_proto_init() {
	if File_yandex_cloud_iam_v1_refresh_token_proto != nil {
		return
	}
	if !protoimpl.UnsafeEnabled {
		file_yandex_cloud_iam_v1_refresh_token_proto_msgTypes[0].Exporter = func(v any, i int) any {
			switch v := v.(*RefreshToken); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
	}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: file_yandex_cloud_iam_v1_refresh_token_proto_rawDesc,
			NumEnums:      1,
			NumMessages:   1,
			NumExtensions: 0,
			NumServices:   0,
		},
		GoTypes:           file_yandex_cloud_iam_v1_refresh_token_proto_goTypes,
		DependencyIndexes: file_yandex_cloud_iam_v1_refresh_token_proto_depIdxs,
		EnumInfos:         file_yandex_cloud_iam_v1_refresh_token_proto_enumTypes,
		MessageInfos:      file_yandex_cloud_iam_v1_refresh_token_proto_msgTypes,
	}.Build()
	File_yandex_cloud_iam_v1_refresh_token_proto = out.File
	file_yandex_cloud_iam_v1_refresh_token_proto_rawDesc = nil
	file_yandex_cloud_iam_v1_refresh_token_proto_goTypes = nil
	file_yandex_cloud_iam_v1_refresh_token_proto_depIdxs = nil
}
