/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha2

import (
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
	v1alpha2 "sigs.k8s.io/gateway-api/apis/v1alpha2"
)

// BackendLBPolicyLister helps list BackendLBPolicies.
// All objects returned here must be treated as read-only.
type BackendLBPolicyLister interface {
	// List lists all BackendLBPolicies in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha2.BackendLBPolicy, err error)
	// BackendLBPolicies returns an object that can list and get BackendLBPolicies.
	BackendLBPolicies(namespace string) BackendLBPolicyNamespaceLister
	BackendLBPolicyListerExpansion
}

// backendLBPolicyLister implements the BackendLBPolicyLister interface.
type backendLBPolicyLister struct {
	listers.ResourceIndexer[*v1alpha2.BackendLBPolicy]
}

// NewBackendLBPolicyLister returns a new BackendLBPolicyLister.
func NewBackendLBPolicyLister(indexer cache.Indexer) BackendLBPolicyLister {
	return &backendLBPolicyLister{listers.New[*v1alpha2.BackendLBPolicy](indexer, v1alpha2.Resource("backendlbpolicy"))}
}

// BackendLBPolicies returns an object that can list and get BackendLBPolicies.
func (s *backendLBPolicyLister) BackendLBPolicies(namespace string) BackendLBPolicyNamespaceLister {
	return backendLBPolicyNamespaceLister{listers.NewNamespaced[*v1alpha2.BackendLBPolicy](s.ResourceIndexer, namespace)}
}

// BackendLBPolicyNamespaceLister helps list and get BackendLBPolicies.
// All objects returned here must be treated as read-only.
type BackendLBPolicyNamespaceLister interface {
	// List lists all BackendLBPolicies in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha2.BackendLBPolicy, err error)
	// Get retrieves the BackendLBPolicy from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha2.BackendLBPolicy, error)
	BackendLBPolicyNamespaceListerExpansion
}

// backendLBPolicyNamespaceLister implements the BackendLBPolicyNamespaceLister
// interface.
type backendLBPolicyNamespaceLister struct {
	listers.ResourceIndexer[*v1alpha2.BackendLBPolicy]
}
